## pico-sdk 2.1.1

=== src/CMakeLists.txt ===
cmake_policy(SET CMP0079 NEW) # allow inserting of dependencies into our INTERFACE libraries
set(PICO_PLATFORM_CMAKE_FILE "${PICO_PLATFORM_CMAKE_FILE}" CACHE INTERNAL "")
set(PICO_DOXYGEN_PATHS "" CACHE INTERNAL "") # generated each time
set(PICO_DOXYGEN_EXCLUDE_PATHS "" CACHE INTERNAL "") # generated each time
set(PICO_DOXYGEN_PRE_DEFINES "" CACHE INTERNAL "") # generated each time
set(PICO_DOXYGEN_ENABLED_SECTIONS "" CACHE INTERNAL "") # generated each time

if (NOT PICO_PLATFORM_CMAKE_DIR)
    set(PICO_PLATFORM_CMAKE_DIR ${CMAKE_CURRENT_LIST_DIR})
endif()
if (NOT PICO_PLATFORM_CMAKE_FILE)
    set(PICO_PLATFORM_CMAKE_FILE ${PICO_PLATFORM_CMAKE_DIR}/${PICO_PLATFORM}.cmake CACHE INTERNAL "")
endif ()

if (NOT EXISTS "${PICO_PLATFORM_CMAKE_FILE}")
    message(FATAL_ERROR "${PICO_PLATFORM_CMAKE_FILE} does not exist. \
    Either specify a valid PICO_PLATFORM (or PICO_PLATFORM_CMAKE_FILE).")
endif ()

# call add_subdirectory(subdir) unless SKIP_SUBDIR evaluates to true
# second argument is optional path
function(pico_add_subdirectory subdir)
    # todo add option to disable skip flag
    string(TOUPPER ${subdir} subdir_upper)
    # we do not include any path part of the subdir
    get_filename_component(subdir_upper ${subdir_upper} NAME)
    set(replace_flag SKIP_${subdir_upper})
    if (NOT ${replace_flag})
        string(TOUPPER ${subdir} subdir_upper)
        set(replace_flag SKIP_${subdir_upper})
        if (${ARGC} GREATER 1)
            # argv1 is the root where the subdir is relative to
            add_subdirectory(${ARGV1}/${subdir} ${subdir})
            # todo make this optional?
            pico_add_doxygen(${ARGV1}/${subdir})
        else()
            add_subdirectory(${subdir})
            # todo make this optional?
            pico_add_doxygen(${subdir})
        endif()
    else()
        message("Not including ${subdir} because ${replace_flag} defined.")
    endif ()
    pico_promote_common_scope_vars()
endfunction()

# takes dependencies after the target
function(pico_mirrored_target_link_libraries TARGET SCOPE)
    if (${ARGC} LESS 3)
        message(FATAL_ERROR "expected a target, scope and at least one dependency")
    endif()
    if (NOT TARGET ${TARGET}_headers)
        message(FATAL_ERROR "${TARGET} does not have headers")
    endif()
    # library should depend on its own header
    target_link_libraries(${TARGET} ${SCOPE} ${TARGET}_headers)
    foreach(DEPENDENCY IN LISTS ARGN)
        if (DEPENDENCY MATCHES ".*_headers")
            message(FATAL_ERROR "should not use headers with pico_mirrored_target_link_libraries")
        endif()
        # note, it would be nice to only add the dependency if it exists, but we do
        # not necessarily add libraries in reverse dependency order, so we do this
        # unconditionally, so this function should only be passed dependencies that
        # have headers, or link will fail with a missing library -lfoo_headers
        target_link_libraries(${TARGET}_headers ${SCOPE} ${DEPENDENCY}_headers)
        target_link_libraries(${TARGET} ${SCOPE} ${DEPENDENCY})
    endforeach()
endfunction()

# add a link option to wrap the given function name; i.e. -Wl:wrap=FUNCNAME for gcc
function(pico_wrap_function TARGET FUNCNAME)
    target_link_options(${TARGET} INTERFACE "LINKER:--wrap=${FUNCNAME}")
endfunction()

# add map file generation for the given target
function(pico_add_map_output TARGET)
    pico_get_runtime_output_directory(${TARGET} output_path)
    get_target_property(target_type ${TARGET} TYPE)
    if ("EXECUTABLE" STREQUAL "${target_type}")
        target_link_options(${TARGET} PRIVATE "LINKER:-Map=${output_path}$<IF:$<BOOL:$<TARGET_PROPERTY:OUTPUT_NAME>>,$<TARGET_PROPERTY:OUTPUT_NAME>,$<TARGET_PROPERTY:NAME>>${CMAKE_EXECUTABLE_SUFFIX}.map")
    else ()
        target_link_options(${TARGET} INTERFACE "LINKER:-Map=${output_path}$<IF:$<BOOL:$<TARGET_PROPERTY:OUTPUT_NAME>>,$<TARGET_PROPERTY:OUTPUT_NAME>,$<TARGET_PROPERTY:NAME>>${CMAKE_EXECUTABLE_SUFFIX}.map")
    endif ()
endfunction()

# create a hardware_NAME_headers target (see pico_simple_hardware_headers_target)
# create a hardware_NAME target (see pico_simple_hardware_target)
macro(pico_simple_hardware_target NAME)
    pico_simple_hardware_headers_target(${NAME})
    pico_simple_hardware_impl_target(${NAME})
endmacro()

# create an INTERFACE library named target, and define LIB_TARGET=1 (upper case) as a compile option
# and make it dependent on a pre-existing corresponding _headers library
# optional arg NOFLAG will skip the LIB_TARGET definition
function(pico_add_impl_library target)
    add_library(${target} INTERFACE)
    string(TOUPPER ${target} TARGET_UPPER)
    if (${ARGC} GREATER 1)
        if (NOT "${ARGV1}" STREQUAL "NOFLAG")
            message(FATAL_ERROR "Unknown parameter ${ARGV1}")
        endif()
    else()
        target_compile_definitions(${target} INTERFACE LIB_${TARGET_UPPER}=1)
    endif()
    target_link_libraries(${target} INTERFACE ${target}_headers)
endfunction()

# create an INTERFACE library named target along with associated header, and define LIB_TARGET=1 (upper case) as a compile option
# optional arg NOFLAG will skip the LIB_TARGET definition
function(pico_add_library target)
    add_library(${target}_headers INTERFACE)
    pico_add_impl_library(${target} ${ARGN})
endfunction()

# create an INTERFACE library named hardware_NAME_headers INTERFACE library if it doesn't already exist,
#        and add include/ relative to the calling directory to the includes.
#        and hardware_structs and hardware_claim as dependencies of the library
macro(pico_simple_hardware_headers_target NAME)
    if (NOT TARGET hardware_${NAME}_headers)
        add_library(hardware_${NAME}_headers INTERFACE)

        target_include_directories(hardware_${NAME}_headers SYSTEM INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include)
        target_link_libraries(hardware_${NAME}_headers INTERFACE pico_base_headers)
        if (NOT PICO_NO_HARDWARE)
            target_link_libraries(hardware_${NAME}_headers INTERFACE hardware_structs hardware_claim_headers)
        endif()
    endif()
endmacro()

# create an INTERFACE library named hardware_NAME if it doesn't exist, along with a hardware_NAME_headers
#        INTERFACE library that it depends on. The hardware_NAME_headers library add include/ relative to
#        and pico_base_headers, and harddware_structs as a dependency of the library
macro(pico_simple_hardware_headers_only_target NAME)
    if (NOT TARGET hardware_${NAME})
        # Choosing not to add LIB_HARDWARE_ defines to avoid command line bloat pending a need (they aren't
        #   super interesting except to determine functionality as they are mostly passive accessors, however
        #   they could be useful to determine if the header is available.
        # pico_add_sdk_impl_library(hardware_${NAME})
        add_library(hardware_${NAME}_headers INTERFACE)

        # a headers only target should still have an explicit _headers library for consistency
        target_include_directories(hardware_${NAME}_headers SYSTEM INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include)
        target_link_libraries(hardware_${NAME}_headers INTERFACE pico_base_headers)
        if (NOT PICO_NO_HARDWARE)
            target_link_libraries(hardware_${NAME}_headers INTERFACE hardware_structs)
        endif()

        add_library(hardware_${NAME} INTERFACE)
        target_link_libraries(hardware_${NAME} INTERFACE hardware_${NAME}_headers)
    endif()
endmacro()

# create an INTERFACE library named hardware_NAME if it doesn't exist, dependent on a pre-existing  hardware_NAME_headers
#        INTERFACE library and pico_platform. The file NAME.c relative to the caller is added to the C sources for the hardware_NAME
macro(pico_simple_hardware_impl_target NAME)
    if (NOT TARGET hardware_${NAME})
        # Choosing not to add LIB_HARDWARE_ defines to avoid command line bloat pending a need (they aren't
        #   super interesting except to determine functionality as they are mostly passive accessors, however
        #   they could be useful to determine if the header is available.
        # pico_add_sdk_impl_library(hardware_${NAME})
        add_library(hardware_${NAME} INTERFACE)

        target_sources(hardware_${NAME} INTERFACE
                ${CMAKE_CURRENT_LIST_DIR}/${NAME}.c
                )

        pico_mirrored_target_link_libraries(hardware_${NAME} INTERFACE pico_platform)
        if (NOT PICO_NO_HARDWARE)
            target_link_libraries(hardware_${NAME} INTERFACE hardware_claim)
        endif()
    endif()
endmacro()

function(pico_add_doxygen_pre_define PRE_DEFINE)
    list(APPEND PICO_DOXYGEN_PRE_DEFINES "${PRE_DEFINE}")
    set(PICO_DOXYGEN_PRE_DEFINES "${PICO_DOXYGEN_PRE_DEFINES}" CACHE INTERNAL "")
endfunction()

function(pico_add_doxygen_enabled_section ENABLED_SECTION)
    list(APPEND PICO_DOXYGEN_ENABLED_SECTIONS "${ENABLED_SECTION}")
    set(PICO_DOXYGEN_ENABLED_SECTIONS "${PICO_DOXYGEN_ENABLED_SECTIONS}" CACHE INTERNAL "")
endfunction()

function(pico_add_doxygen SOURCE_DIR)
    if (NOT IS_ABSOLUTE "${SOURCE_DIR}")
        get_filename_component(SOURCE_DIR "${SOURCE_DIR}" ABSOLUTE BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    endif()
    list(APPEND PICO_DOXYGEN_PATHS "${SOURCE_DIR}")
    set(PICO_DOXYGEN_PATHS "${PICO_DOXYGEN_PATHS}" CACHE INTERNAL "")
endfunction()

function(pico_add_doxygen_exclude SOURCE_DIR)
    if (NOT IS_ABSOLUTE "${SOURCE_DIR}")
        get_filename_component(SOURCE_DIR "${SOURCE_DIR}" ABSOLUTE BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    endif()
    list(APPEND PICO_DOXYGEN_EXCLUDE_PATHS "${SOURCE_DIR}")
    set(PICO_DOXYGEN_EXCLUDE_PATHS "${PICO_DOXYGEN_EXCLUDE_PATHS}" CACHE INTERNAL "")
endfunction()

include(${PICO_PLATFORM_CMAKE_FILE})

pico_promote_common_scope_vars()

=== test/kitchen_sink/CMakeLists.txt ===
add_library(kitchen_sink_libs INTERFACE)

set(KITCHEN_SINK_LIBS
    hardware_adc
    hardware_clocks
    hardware_divider
    hardware_dma
    hardware_exception
    hardware_flash
    hardware_gpio
    hardware_i2c
    hardware_interp
    hardware_irq
    hardware_pio
    hardware_powman
    hardware_pll
    hardware_pwm
    hardware_resets
    hardware_rtc
    hardware_spi
    hardware_sync
    hardware_ticks
    hardware_timer
    hardware_uart
    hardware_vreg
    hardware_watchdog
    hardware_xip_cache
    hardware_xosc
    pico_aon_timer
    pico_bit_ops
    pico_bootrom
    pico_bootsel_via_double_reset
    pico_divider
    pico_double
    pico_fix_rp2040_usb_device_enumeration
    pico_flash
    pico_float
    pico_i2c_slave
    pico_int64_ops
    pico_malloc
    pico_mem_ops
    pico_multicore
    pico_platform
    pico_rand
    pico_sha256
    pico_stdlib
    pico_sync
    pico_time
    pico_unique_id
    pico_util
)

foreach(LIB IN LISTS KITCHEN_SINK_LIBS)
    if (TARGET ${LIB})
        target_link_libraries(kitchen_sink_libs INTERFACE ${LIB})
    endif()
endforeach ()

add_library(kitchen_sink_options INTERFACE)

target_compile_options(kitchen_sink_options INTERFACE
        -Werror
        -Wall
        -Wextra
        #        -pedantic

        -Wnull-dereference
        -Wuninitialized
        -Wunused
        -Wcast-align
        -Wcast-qual
        -Wfloat-equal
        -Wmissing-format-attribute
        #-Wconversion
        -Wsign-compare
        $<$<COMPILE_LANGUAGE:C>:-Wstrict-prototypes>
        # todo we have some of these in usb_device_tiny to try to make it more readable.. perhaps doxygen would help here instead
        -Wredundant-decls

        -Wno-inline
        # todo not sure these are true, but investigate
        #-Wpacked

        # todo useful but fix later
        #-Wundef
        )

if (PICO_C_COMPILER_IS_CLANG)
    # todo fix up clang warnings
    target_compile_options(kitchen_sink_options INTERFACE
            -Wno-cast-qual
            -Wno-unused-function
            -Wno-format)
endif()

target_compile_definitions(kitchen_sink_libs INTERFACE
        PICO_FORBID_ARM_HEADERS_ON_RISCV=1
        PARAM_ASSERTIONS_ENABLE_ALL=1 # want to check all the assertions for compilation warnings
        PICO_AUDIO_DMA_IRQ=1
)

add_executable(kitchen_sink ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
target_link_libraries(kitchen_sink kitchen_sink_libs kitchen_sink_options)
pico_set_program_name(kitchen_sink "Wombat tentacles")
pico_add_extra_outputs(kitchen_sink)
target_compile_definitions(kitchen_sink PRIVATE KITCHEN_SINK_ID="regular binary")

add_executable(kitchen_sink_extra_stdio ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
if (COMMAND suppress_tinyusb_warnings)
    # Explicitly suppress warnings in TinyUSB files which have them (this has to be done
    # from the project that uses them per CMake "feature"). Note the function comes from
    # TinyUSB itself, so we have to guard against TinyUSB not being present with the above if
    suppress_tinyusb_warnings()
endif()
target_compile_definitions(kitchen_sink_extra_stdio PRIVATE
        TUD_OPT_RP2040_USB_DEVICE_ENUMERATION_FIX=1)
if (TARGET pico_lwip)
    set_source_files_properties(
            ${PICO_LWIP_PATH}/src/core/ipv4/ip4_frag.c
            PROPERTIES
            COMPILE_FLAGS "-Wno-null-dereference")

endif()
target_link_libraries(kitchen_sink_extra_stdio kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_extra_stdio)
pico_enable_stdio_usb(kitchen_sink_extra_stdio 1)
pico_enable_stdio_semihosting(kitchen_sink_extra_stdio 1)

add_executable(kitchen_sink_printf_compiler ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
target_link_libraries(kitchen_sink_printf_compiler kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_printf_compiler)
pico_set_printf_implementation(kitchen_sink_printf_compiler compiler)

add_executable(kitchen_sink_printf_compiler_no_shortcircuit ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
target_link_libraries(kitchen_sink_printf_compiler_no_shortcircuit kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_printf_compiler_no_shortcircuit)
pico_set_printf_implementation(kitchen_sink_printf_compiler_no_shortcircuit compiler)
target_compile_definitions(kitchen_sink_printf_compiler_no_shortcircuit PRIVATE PICO_STDIO_SHORT_CIRCUIT_CLIB_FUNCS=0)


add_executable(kitchen_sink_printf_none ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
target_link_libraries(kitchen_sink_printf_none kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_printf_none)
pico_set_printf_implementation(kitchen_sink_printf_none none)

add_executable(kitchen_sink_copy_to_ram ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
pico_set_binary_type(kitchen_sink_copy_to_ram copy_to_ram)
target_link_libraries(kitchen_sink_copy_to_ram kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_copy_to_ram)
target_compile_definitions(kitchen_sink_copy_to_ram PRIVATE KITCHEN_SINK_ID="copy-to-ram binary")

add_executable(kitchen_sink_no_flash ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
pico_set_binary_type(kitchen_sink_no_flash no_flash)
target_link_libraries(kitchen_sink_no_flash kitchen_sink_libs kitchen_sink_options)
pico_add_extra_outputs(kitchen_sink_no_flash)
target_compile_definitions(kitchen_sink_no_flash PRIVATE KITCHEN_SINK_ID="no-flash binary")

if (NOT PICO_RP2350)
    # RP2350 does not have blocked ram
    add_executable(kitchen_sink_blocked_ram ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
    pico_set_binary_type(kitchen_sink_blocked_ram blocked_ram)
    target_link_libraries(kitchen_sink_blocked_ram kitchen_sink_libs kitchen_sink_options)
    pico_add_extra_outputs(kitchen_sink_blocked_ram)
    target_compile_definitions(kitchen_sink_blocked_ram PRIVATE KITCHEN_SINK_ID="blocked-ram binary")
endif()

add_executable(kitchen_sink_cpp ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink_cpp.cpp)
target_link_libraries(kitchen_sink_cpp kitchen_sink_libs kitchen_sink_options)
pico_set_program_name(kitchen_sink_cpp "Wombat tentacles CPP")
pico_add_extra_outputs(kitchen_sink_cpp)

if (TARGET pico_cyw43_arch)
    # for lwipopts.h
    add_executable(kitchen_sink_lwip_poll ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
    target_link_libraries(kitchen_sink_lwip_poll kitchen_sink_libs kitchen_sink_options)
    pico_add_extra_outputs(kitchen_sink_lwip_poll)
    target_link_libraries(kitchen_sink_lwip_poll
            pico_cyw43_arch_lwip_poll)
    if (TARGET pico_btstack)
        target_link_libraries(kitchen_sink_lwip_poll
            pico_btstack_ble pico_btstack_classic pico_btstack_cyw43)
    endif()
    # for lwipopts.h and btstack_config.h.
    target_include_directories(kitchen_sink_lwip_poll PRIVATE
            ${CMAKE_CURRENT_LIST_DIR})

    add_executable(kitchen_sink_lwip_background ${CMAKE_CURRENT_LIST_DIR}/kitchen_sink.c)
    target_link_libraries(kitchen_sink_lwip_background kitchen_sink_libs kitchen_sink_options)
    pico_add_extra_outputs(kitchen_sink_lwip_background)
    target_link_libraries(kitchen_sink_lwip_background
            pico_cyw43_arch_lwip_threadsafe_background)
    # for lwipopts.h
    target_include_directories(kitchen_sink_lwip_background PRIVATE
            ${CMAKE_CURRENT_LIST_DIR})

    if (TARGET pico_lwip_mbedtls)
        target_link_libraries(kitchen_sink_lwip_poll pico_lwip_mbedtls)
        target_link_libraries(kitchen_sink_lwip_background pico_lwip_mbedtls)
    endif()
    if (TARGET pico_mbedtls)
        target_link_libraries(kitchen_sink_lwip_poll pico_mbedtls)
        target_link_libraries(kitchen_sink_lwip_background pico_mbedtls)
        suppress_mbedtls_warnings()
    endif()
endif()

if (TARGET pico_btstack_base AND COMMAND suppress_btstack_warnings)
    suppress_btstack_warnings()
endif()

=== test/pico_divider_test/CMakeLists.txt ===
PROJECT(pico_divider_test)

if (PICO_ON_DEVICE)
    add_executable(pico_divider_test
            pico_divider_test.c
            )

    target_link_libraries(pico_divider_test pico_stdlib)

    if (PICO_RP2040)
        pico_set_divider_implementation(pico_divider_test hardware_explicit) # want to compare against compiler impl
    endif()

    pico_add_extra_outputs(pico_divider_test)

    target_compile_definitions(pico_divider_test PRIVATE
#            PICO_DIVIDER_DISABLE_INTERRUPTS=1
#            TURBO
    )

    # this is a separate test as hardware_explicit above causes it not to be tested at all!
    add_library(pico_divider_nesting_test_core INTERFACE)
    target_sources(pico_divider_nesting_test_core INTERFACE
            pico_divider_nesting_test.c
    )
    target_link_libraries(pico_divider_nesting_test_core INTERFACE pico_stdlib hardware_dma)

    add_executable(pico_divider_nesting_test_with_dirty_check)
    target_link_libraries(pico_divider_nesting_test_with_dirty_check pico_divider_nesting_test_core)
    if (PICO_RP2040)
        pico_set_divider_implementation(pico_divider_nesting_test_with_dirty_check hardware)
    endif()
    pico_add_extra_outputs(pico_divider_nesting_test_with_dirty_check)

    add_executable(pico_divider_nesting_test_with_disable_irq)
    target_link_libraries(pico_divider_nesting_test_with_disable_irq pico_divider_nesting_test_core)
    target_compile_definitions(pico_divider_nesting_test_with_disable_irq PRIVATE
            PICO_DIVIDER_DISABLE_INTERRUPTS=1)
    if (PICO_RP2040)
        pico_set_divider_implementation(pico_divider_nesting_test_with_disable_irq hardware)
    endif()
    pico_add_extra_outputs(pico_divider_nesting_test_with_disable_irq)

endif()

=== test/pico_float_test/CMakeLists.txt ===
PROJECT(pico_float_test)


if (PICO_RISCV)

    # Separate, simpler test: currently we only have a few single-precision
    # routines for RISC-V soft float (and the other tests are a bit
    # AEABI-dependent)
    add_executable(pico_float_test
        pico_float_test_hazard3.c
        )
    target_link_libraries(pico_float_test PRIVATE pico_float pico_stdlib)
    target_include_directories(pico_float_test PRIVATE ${CMAKE_CURRENT_LIST_DIR})
    pico_add_extra_outputs(pico_float_test)

    # pico_enable_stdio_usb(pico_float_test 1)
    # pico_enable_stdio_uart(pico_float_test 0)

else ()
    add_executable(pico_float_test
            pico_float_test.c
            llvm/call_apsr.S
            )

    add_executable(pico_double_test
            pico_double_test.c
            llvm/call_apsr.S
            )


    #todo split out variants with different flags
    target_compile_definitions(pico_float_test PRIVATE
    #        PICO_FLOAT_PROPAGATE_NANS=1
    #        PICO_DIVIDER_DISABLE_INTERRUPTS=1
    )

    #todo split out variants with different flags
    target_compile_definitions(pico_double_test PRIVATE
            PICO_USE_CRT_PRINTF=1 # want full precision output
            PICO_FLOAT_PROPAGATE_NANS=1
            PICO_DOUBLE_PROPAGATE_NANS=1
                    #PICO_DIVIDER_DISABLE_INTERRUPTS=1
            )
    if (NOT PICO_CLIB STREQUAL "llvm_libc")
        # raw compiler printf on llvm_libc doesn't currently have floating point
        pico_set_printf_implementation(pico_double_test compiler) # want full precision output
    endif()

    # handy for testing we aren't pulling in extra stuff
    #target_link_options(pico_float_test PRIVATE -nodefaultlibs)

    target_include_directories(pico_float_test PRIVATE ${CMAKE_CURRENT_LIST_DIR}/llvm)
    target_link_libraries(pico_float_test pico_float pico_stdlib)
    pico_add_extra_outputs(pico_float_test)
    #pico_set_float_implementation(pico_float_test compiler)
    #pico_set_float_implementation(pico_float_test pico_vfp)
    #pico_set_double_implementation(pico_float_test compiler)

    target_include_directories(pico_double_test PRIVATE ${CMAKE_CURRENT_LIST_DIR}/llvm)
    target_link_libraries(pico_double_test pico_double pico_stdlib)
    pico_add_extra_outputs(pico_double_test)
    #pico_set_float_implementation(pico_double_test compiler)
    #pico_set_double_implementation(pico_double_test compiler)

    if (PICO_RP2350 AND NOT PICO_RISCV)
        add_executable(m33
                m33.c
                )

        target_compile_definitions(m33 PRIVATE
                PICO_USE_CRT_PRINTF=1 # want full precision output
                PICO_FLOAT_PROPAGATE_NANS=1
                PICO_DOUBLE_PROPAGATE_NANS=1
                #PICO_DIVIDER_DISABLE_INTERRUPTS=1
                )
        pico_set_printf_implementation(m33 compiler) # want full precision output
        pico_set_float_implementation(m33 pico)
        pico_set_double_implementation(m33 pico)
        target_link_libraries(m33 pico_double pico_stdlib)
        pico_add_extra_outputs(m33)
    endif()

endif()

set(FLOAT_TYPES compiler)
set(DOUBLE_TYPES compiler)
list(APPEND FLOAT_TYPES pico)
list(APPEND DOUBLE_TYPES pico)
if (PICO_RP2350)
    if (NOT PICO_RISCV)
        list(APPEND FLOAT_TYPES pico_vfp pico_dcp)
    endif()
endif()

foreach (FLOAT_TYPE IN LISTS FLOAT_TYPES)
    add_executable(custom_float_funcs_test_${FLOAT_TYPE} custom_float_funcs_test.c)
    pico_set_float_implementation(custom_float_funcs_test_${FLOAT_TYPE} ${FLOAT_TYPE})
    target_link_libraries(custom_float_funcs_test_${FLOAT_TYPE} PRIVATE pico_stdlib)
    pico_add_extra_outputs(custom_float_funcs_test_${FLOAT_TYPE})
    pico_set_printf_implementation(custom_float_funcs_test_${FLOAT_TYPE} compiler)
endforeach ()

foreach (DOUBLE_TYPE IN LISTS DOUBLE_TYPES)
    add_executable(custom_double_funcs_test_${DOUBLE_TYPE} custom_double_funcs_test.c)
    pico_set_double_implementation(custom_double_funcs_test_${DOUBLE_TYPE} ${DOUBLE_TYPE})
    target_link_libraries(custom_double_funcs_test_${DOUBLE_TYPE} PRIVATE pico_stdlib)
    pico_add_extra_outputs(custom_double_funcs_test_${DOUBLE_TYPE})
    pico_set_printf_implementation(custom_double_funcs_test_${DOUBLE_TYPE} compiler)
endforeach ()

=== test/pico_stdlib_test/CMakeLists.txt ===
add_executable(pico_stdlib_test pico_stdlib_test.c)

target_compile_definitions(pico_stdlib_test PRIVATE
        #PICO_ENTER_USB_BOOT_ON_EXIT=1
)

target_link_libraries(pico_stdlib_test PRIVATE pico_stdlib)
pico_add_extra_outputs(pico_stdlib_test)

=== tools/pioasm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...3.27)
project(pioasm CXX)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_STANDARD 11)

if (PIOASM_GENERATE_PARSER)
    find_package(BISON 3.4.2)
    find_package(FLEX 2.5.13) # no idea about the version

    FLEX_TARGET(pioasm_lexer lexer.ll ${CMAKE_CURRENT_SOURCE_DIR}/gen/lexer.cpp)
    BISON_TARGET(pioasm_parser parser.yy ${CMAKE_CURRENT_SOURCE_DIR}/gen/parser.cpp COMPILE_FLAGS "-Wcounterexamples")
    ADD_FLEX_BISON_DEPENDENCY(pioasm_lexer pioasm_parser)
endif()

add_executable(pioasm
        main.cpp
        pio_assembler.cpp
        pio_disassembler.cpp
        gen/lexer.cpp
        gen/parser.cpp
)

target_sources(pioasm PRIVATE c_sdk_output.cpp)
target_sources(pioasm PRIVATE python_output.cpp)
target_sources(pioasm PRIVATE hex_output.cpp)
target_sources(pioasm PRIVATE json_output.cpp)
target_sources(pioasm PRIVATE ada_output.cpp)
target_sources(pioasm PRIVATE go_output.cpp)
target_sources(pioasm PRIVATE ${PIOASM_EXTRA_SOURCE_FILES})
target_sources(pioasm PRIVATE pio_types.h)

if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "7") AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9") AND
    (CMAKE_SYSTEM_PROCESSOR MATCHES "^arm.*$"))
    # disable GCC ARM info notice about ABI change
    target_compile_options(pioasm PRIVATE -Wno-psabi)
endif()

target_include_directories(pioasm PRIVATE ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/gen)

if (MSVC OR
    (WIN32 AND NOT MINGW AND (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")))
    target_compile_definitions(pioasm PRIVATE YY_NO_UNISTD_H)
endif()
if (MSVC)
    target_compile_options(pioasm PRIVATE "/std:c++latest")
endif()


# allow installing to flat dir
include(GNUInstallDirs)
if (PIOASM_FLAT_INSTALL)
    set(INSTALL_CONFIGDIR pioasm)
    set(INSTALL_BINDIR pioasm)
else()
    set(INSTALL_CONFIGDIR lib/cmake/pioasm)
    set(INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
endif()

# allow `make install`
install(TARGETS pioasm
    EXPORT pioasm-targets
    RUNTIME DESTINATION ${INSTALL_BINDIR}
)

#Export the targets to a script
install(EXPORT pioasm-targets
    FILE
        pioasmTargets.cmake
    DESTINATION
        ${INSTALL_CONFIGDIR}
)

include(../../pico_sdk_version.cmake)
set(PACKAGE_VERSION "${PICO_SDK_VERSION_MAJOR}.${PICO_SDK_VERSION_MINOR}.${PICO_SDK_VERSION_REVISION}")

#Create a ConfigVersion.cmake file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/pioasmConfigVersion.cmake
    VERSION ${PACKAGE_VERSION}
    COMPATIBILITY ExactVersion
    ARCH_INDEPENDENT
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/pioasmConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/pioasmConfig.cmake
    INSTALL_DESTINATION ${INSTALL_CONFIGDIR}
)

#Install the config and configversion
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pioasmConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/pioasmConfigVersion.cmake
    DESTINATION ${INSTALL_CONFIGDIR}
)

=== src/common/boot_picoboot_headers/CMakeLists.txt ===
add_library(boot_picoboot_headers INTERFACE)
target_include_directories(boot_picoboot_headers SYSTEM INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include)

=== src/host/pico_time_adapter/CMakeLists.txt ===
pico_add_library(pico_time_adapter)

target_sources(pico_time_adapter INTERFACE
        ${CMAKE_CURRENT_LIST_DIR}/time_adapter.c
)

target_include_directories(pico_time_adapter_headers SYSTEM INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include)

pico_mirrored_target_link_libraries(pico_time INTERFACE pico_time_adapter)

=== src/rp2_common/hardware_clocks/CMakeLists.txt ===
pico_simple_hardware_target(clocks)

pico_mirrored_target_link_libraries(hardware_clocks INTERFACE
        hardware_gpio
        hardware_irq
        hardware_resets
        hardware_pll
        # not currently used by clocks.c, but sensibly bundled here
        # as changing frequencies may require upping voltage
        hardware_vreg
        hardware_watchdog
        hardware_xosc
)

if (PICO_USE_FASTEST_SUPPORTED_CLOCK)
    target_compile_definitions(hardware_clocks INTERFACE PICO_USE_FASTEST_SUPPORTED_CLOCK=1)
endif()

=== src/rp2_common/hardware_dcp/CMakeLists.txt ===
pico_simple_hardware_headers_only_target(dcp)

=== src/rp2_common/hardware_dma/CMakeLists.txt ===
pico_simple_hardware_target(dma)
pico_mirrored_target_link_libraries(hardware_dma INTERFACE hardware_claim)

=== src/rp2_common/hardware_uart/CMakeLists.txt ===
pico_simple_hardware_target(uart)

pico_mirrored_target_link_libraries(hardware_uart INTERFACE hardware_resets hardware_clocks)

# PICO_CMAKE_CONFIG: PICO_DEFAULT_UART_BAUD_RATE, Define the default UART baudrate, type=int, max=921600, default=115200, group=hardware_uart
if (PICO_DEFAULT_UART_BAUD_RATE)
target_compile_definitions(hardware_uart INTERFACE
        PICO_DEFAULT_UART_BAUD_RATE=${PICO_DEFAULT_UART_BAUD_RATE})
endif()

=== debian/changelog ===
pico-sdk (2.1.1-1) unstable; urgency=medium

  * debian/control: demote picotool to Recommends
  * debian/tests/control: add picotool to Depends
  * debian/control: wrap-and-sort -astb
  * New upstream version 2.1.1 (closes: #1100331)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 17 Mar 2025 09:25:49 +0100

=== debian/control ===
Source: pico-sdk
Section: libdevel
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Homepage: https://github.com/raspberrypi/pico-sdk/issues
Vcs-Browser: https://salsa.debian.org/debian/pico-sdk
Vcs-Git: https://salsa.debian.org/debian/pico-sdk.git
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Build-Depends-Indep:
 doxygen,
 gcc-arm-none-eabi,
 graphviz,
 libnewlib-arm-none-eabi,
 libstdc++-arm-none-eabi-newlib,
 python3,
 tinyusb-source,

Package: pico-sdk-source
Architecture: all
Depends:
 cmake,
 gcc-arm-none-eabi,
 libnewlib-arm-none-eabi,
 libstdc++-arm-none-eabi-newlib,
 pioasm,
 python3,
 tinyusb-source,
 ${misc:Depends},
Recommends:
 picotool (>= 2.0),
Multi-Arch: foreign
Description: headers and libraries to write programs for RP2040-based devices
 The Raspberry Pi Pico SDK provides the headers, libraries and build system
 necessary to write programs for the RP2040-based devices such as the Raspberry
 Pi Pico in C, C++ or assembly language.
 .
 The SDK is designed to provide an API and programming environment that is
 familiar both to non-embedded C developers and embedded C developers alike. A
 single program runs on the device at a time and starts with a conventional
 main() method. Standard C/C++ libraries are supported along with C level
 libraries/APIs for accessing all of the RP2040's hardware include PIO.
 .
 Additionally the SDK provides higher level libraries for dealing with timers,
 synchronization, USB (TinyUSB) and multi-core programming along with various
 utilities.
 .
 The SDK can be used to build anything from simple applications, to fully
 fledged runtime environments such as MicroPython, to low level software such
 as RP2040's on-chip bootrom itself.

Package: pioasm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: Assemble file of PIO program(s) for use in applications
 For the development of applications for the Raspberry Pi with the Pico SDK.
 Available output formats are c-sdk, python, hex, ada and go. The default
 output is c-skd.

=== debian/rules ===
#!/usr/bin/make -f

# arm-none-eabi-gcc does not support branch protection instructions
# arm-none-eabi-gcc does not support -fstack-check=specific
export DEB_BUILD_MAINT_OPTIONS = hardening=-branch,-stackclash

CFLAGS += -DPICO_PROGRAM_BUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\""

DEB_HOST_GNU_TYPE ?=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# we do not ship the resulting binaries but we want to make sure that the sdk
# can be built on this architecture
CMAKEFLAGS += -DPICO_SDK_TESTS_ENABLED=ON

# other than the source, we ship the docs
CMAKEFLAGS += -DPICO_BUILD_DOCS=ON

# setting PICO_EXAMPLES_PATH=/dev/null to avoid requiring
# a git clone of https://github.com/raspberrypi/pico-examples
CMAKEFLAGS += -DPICO_EXAMPLES_PATH=/dev/null

# to avoid a circular build dependency loop with picotool, it gets disabled
# it will skip anything that requires picotool, i.e UF2s for the test programs
CMAKEFLAGS += -DPICO_NO_PICOTOOL=ON

%:
	dh $@

execute_before_dh_auto_configure-indep:
	mkdir -p ./lib
	ln -s /usr/src/tinyusb ./lib/tinyusb
	test -e ./lib/tinyusb/src/portable/raspberrypi/rp2040

override_dh_auto_configure-indep:
	dh_auto_configure -- $(CMAKEFLAGS)

override_dh_auto_configure-arch:
	dh_auto_configure --sourcedirectory=tools/pioasm --builddirectory=pioasm-obj-$(DEB_HOST_GNU_TYPE)

override_dh_installdocs-indep:
	cp -a debian/roboto-debian.css obj-$(DEB_HOST_GNU_TYPE)/docs/doxygen/html/
	dh_installdocs obj-$(DEB_HOST_GNU_TYPE)/docs/doxygen/html/

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=tools/pioasm --builddirectory=pioasm-obj-$(DEB_HOST_GNU_TYPE)

# CMakeLists.txt unconditionally runs add_subdirectory(docs) but we don't want
# to ship the documentation source with pico-sdk-source so we create a dummy
override_dh_auto_install-indep:
	mkdir -p debian/pico-sdk-source/usr/src/pico-sdk/docs
	touch debian/pico-sdk-source/usr/src/pico-sdk/docs/CMakeLists.txt

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=tools/pioasm --builddirectory=pioasm-obj-$(DEB_HOST_GNU_TYPE)

execute_before_dh_auto_clean:
	if [ -d ./lib/tinyusb ]; then rmdir ./lib/tinyusb; else rm -f ./lib/tinyusb; fi
	# remove empty directories so they don't get shipped in the binary package
	[ ! -d ./lib ] || find ./lib/ -type d -empty -delete
